
--[[
	We setup the global table for our mod, along with some path variables, and a data table.
	We cache the ModPath directory, so that when our hooks are called, we aren't using the ModPath from a
		different mod.
]]
_G.CorpseDelimiter = _G.CorpseDelimiter or {}
CorpseDelimiter._path = ModPath
CorpseDelimiter.options_path = SavePath .. "CorpseDelimiter.txt"
CorpseDelimiter.options = {}


Hooks:Add("LocalizationManagerPostInit", "LocalizationManagerPostInit_CorpseDelimiter", function( loc )
	loc:load_localization_file( CorpseDelimiter._path .. "Loc/en.txt")
end)

--[[
	Setup our menu callbacks, load our saved data, and build the menu from our json file.
]]
Hooks:Add( "MenuManagerInitialize", "MenuManagerInitialize_CorpseDelimiter", function( menu_manager )

	--[[
		Setup our callbacks as defined in our item callback keys, and perform our logic on the data retrieved.
	]]

	MenuCallbackHandler.DoRemoveAllCorpses = function(self)
		if managers.enemy and not managers.groupai:state():whisper_mode() then
			managers.enemy:dispose_all_corpses()
		end
	end

	MenuCallbackHandler.DoRemoveAllShields = function(self)
		if managers.enemy then

			local enemy_data = managers.enemy._enemy_data
			local corpses = enemy_data.corpses
			for u_key, u_data in pairs(corpses) do
				if u_data.unit:inventory() ~= nil then
					u_data.unit:inventory():destroy_all_items()
				end
			end

		end
	end

	--[[
		Load our previously saved data from our save file.
	]]
	

	--[[
		Load our menu json file and pass it to our MenuHelper so that it can build our in-game menu for us.
		We pass our parent mod table as the second argument so that any keybind functions can be found and called
			as necessary.
		We also pass our data table as the third argument so that our saved values can be loaded from it.
	]]
	MenuHelper:LoadFromJsonFile( CorpseDelimiter._path .. "Menu/corpse_mod_menu.txt", CorpseDelimiter, CorpseDelimiter.options )

end )
